﻿@model  RealEstate.Models.UserSalaryModel

@{
    ViewBag.Title = "Salary Manager";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

@{

    var rolename = HttpContext.Current.Session["rolename"].ToString();
}

<style>
    .modal-backdrop {
        position: unset;
        top: 0;
        right: 0;
        bottom: 0;
        left: 0;
        z-index: 1040;
        background-color: #000;
    }

    .modal {
        position: fixed;
        top: 23%;
        right: 0;
        bottom: 0;
        left: 0;
        z-index: 1050;
        display: none;
        overflow: hidden;
        outline: 0;
    }
</style>


<!-- Modal -->
<div id="salaryModal" class="modal fade" role="dialog">
    <div class="modal-dialog">

        <!-- Modal content-->
        <div class="modal-content" style="width:72em">
            <div class="modal-header">
                <h4 class="modal-title">Modal Header</h4>
                <button type="button" class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body" style="width:72em">
                <table id="detail_tbl" class="table table-bordered">
                    <thead>
                        <tr>
                            <th>Mode</th>
                            <th>Date</th>
                            <th style=" text-align:left">Amt Paid</th>
                            <th>Remaining Amt</th>
                            <th>Ref Id</th>
                            <th>Status</th>
                            <th>Message</th>
                            <th>Remarks</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>
                    </tbody>

                </table>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
            </div>
        </div>

    </div>
</div>


@using (Html.BeginForm("Generate_Salary", "Salary", FormMethod.Post))
{
    @Html.AntiForgeryToken()
    @Html.ValidationSummary(true, "", new { @class = "text-danger" })


    <div class="row">
        <div class="col-xl-12 ">
            <div class="card bg-white text-black mb-1">
                <div class="card-body text-center">
                    <div class="row" style="margin-top:1em;">
                        <div class="col-sm-6">
                            <div class="form-group">
                                @Html.Label("Total Amount", htmlAttributes: new { @class = "control-label col-md-5 text-left" })
                                <div class="col-md-7 float-right">
                                    @Html.EditorFor(model => model.Total_Amount, new { htmlAttributes = new { @class = "form-control", autocomplete = "off", disabled = "disabled" } })
                                </div>
                            </div>
                        </div>

                        @*<div class="col-sm-6">
                                <div class="form-group">
                                    @Html.Label("Payable Amount", htmlAttributes: new { @class = "control-label col-md-5 text-left" })
                                    <div class="col-md-7 float-right">
                                        <span class="badges badges-info" id="txt_total_payable_amt">0</span>
                                    </div>
                                </div>
                            </div>*@

                    </div>


                </div>
            </div>
        </div>
    </div>

    <div class="row">
        <div class="col-xl-12 ">
            <div class="card bg-white text-black mb-1">
                <div class="card-body text-center">
                    <div class="row" style="margin-top:1em;">

                        <div class="col-sm-6">
                            <div class="form-group">
                                @Html.LabelFor(model => model.Month_Year, htmlAttributes: new { @class = "control-label col-md-5 text-left" })
                                <div class="col-md-7 float-right">
                                    @Html.EditorFor(model => model.Month_Year, new { htmlAttributes = new { @class = "form-control monthpicker", autocomplete = "off" } })
                                    @Html.ValidationMessageFor(model => model.Month_Year, "", new { @class = "text-danger" })
                                </div>
                            </div>
                        </div>

                        @if (rolename.ToLower().Contains("admin"))
                        {
                            <div class="col-sm-6">
                                <div class="form-group">
                                    <button class="btn btn-primary control-label col-md-3" type="submit">Generate</button>
                                    <div class="col-md-7 float-right">
                                        <button id="btn_pay" class="btn btn-primary control-label col-md-3" type="button">Pay</button>
                                    </div>
                                </div>
                            </div>
                        }
                    </div>
                </div>
            </div>
        </div>
    </div>

    <div class="row">
        <div class="col-xl-12 ">
            <div class="card bg-white text-black mb-1">
                <h5 class="card-header text-center">Salary for the month of : <span class="badge badge-danger">@Model.Month_Year</span> </h5>
                <div class="card-body text-center">
                    <div class="datatable table-responsive">
                        <div id="dataTable_wrapper" class="dataTables_wrapper dt-bootstrap4">
                            <div class="table-responsive col-sm-12">
                                <table id="example" class="table">
                                    <thead>
                                        <tr>
                                            <th><input type="checkbox" name="select_all" value="1" id="example-select-all"></th>
                                            <th style=" text-align:left">Name</th>
                                            <th>Project</th>
                                            <th>Days Worked</th>
                                            <th>Loan</th>
                                            <th>Calculated Salary</th>
                                            <th>ESIC</th>
                                            <th>Cash Paid</th>
                                            <th>Account Pay</th>
                                            <th>Remaining Amount</th>
                                            <th>Remarks</th>
                                            <th>Details</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @foreach (var x in Model.UserSalary)
                                        {
                                            <tr>
                                                <td>
                                                    @if (x.Active_Bank_Account)
                                                    {
                                                        if (string.IsNullOrEmpty(x.CF_referenceId))
                                                        {
                                                            <input type="checkbox" name="select_all" class="ckb_user" id="@x.UserId">
                                                        }
                                                        else
                                                        {
                                                            <span class="badge badge-success">Paid</span>
                                                        }
                                                    }
                                                    else
                                                    {
                                                        <span class="badge badge-danger">In-Active A/C</span>
                                                    }
                                                </td>
                                                <td style="color: blue; text-align:left">
                                                    <a href="/User/AddEditUser/@x.UserId">@x.Name</a>
                                                </td>
                                                <td>@x.Project</td>
                                                <td>@x.Total_Days_Worked</td>
                                                <td>@x.Loan</td>
                                                <td>@x.Calculated_Salary</td>
                                                <td>
                                                    <input type="text" class="ESIC" value="@x.ESIC" style="width:50px">
                                                </td>

                                                <td>
                                                    <input type="text" class="Cash_Pay" value="@x.Cash_Pay" style="width:50px" onkeyup="Validate_Payable(this)">
                                                </td>

                                                <td>
                                                    <input type="text" class="Account_Pay" value="@x.Account_Pay" style="width:50px" onkeyup="Validate_Payable(this)">
                                                </td>

                                                <td>
                                                    <span class="Remaining_Amount" data-rem-amt="@x.Remaining_Amount">   @x.Remaining_Amount</span>
                                                </td>

                                                <td>
                                                    <input type="text" class="Remarks" value="@x.Remarks" style="width:50px">
                                                </td>

                                                <td>
                                                    <span><a htrf="#" onclick="View_Details(@x.UserId);"><i class="fa fa-eye" style="font-size:19px"></i></a></span>
                                                </td>
                                            </tr>
                                        }
                                    </tbody>

                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
}




@section Scripts {
    <script type="text/javascript">

        $('.monthpicker').MonthPicker({
            MinMonth: -12, Button: false, MonthFormat: 'M yy', OnAfterChooseMonth: function () {
                showloader(true)
                window.location.href = "/Salary/Index?Month_Year=" + $(this).val();
            }
        });






        $(document).ready(function () {
            var table = $('#example').DataTable({});

            // Add event listener for opening and closing details
            $('#example tbody').on('click', 'td.details-control', function () {
                var tr = $(this).closest('tr');
                var row = table.row(tr);

                if (row.child.isShown()) {
                    // This row is already open - close it
                    row.child.hide();
                    tr.removeClass('shown');
                }
                else {
                    // Open this row
                    row.child(format(row.data())).show();
                    tr.addClass('shown');
                }
            });



            // Handle click on "Select all" control
            $('#example-select-all').on('click', function () {
                // Get all rows with search applied
                var rows = table.rows({ 'search': 'applied' }).nodes();
                // Check/uncheck checkboxes for all rows in the table
                $('input[type="checkbox"]', rows).prop('checked', this.checked);


                if ($(this).is(":checked")) {
                    var Total_Amount = $("#Total_Amount").val();
                    Calc_total_payable(Total_Amount)
                } else {
                    Calc_total_payable(0)
                }
            });

            // Handle click on checkbox to set state of "Select all" control
            $('#example tbody').on('change', 'input[type="checkbox"]', function () {
                // If checkbox is not checked
                if (!this.checked) {
                    var Cash_Pay = $(this).closest('tr').find('.Cash_Pay').val();
                    Cash_Pay = Cash_Pay == "" ? 0 : Cash_Pay
                    Cash_Pay = parseFloat(Cash_Pay)
                    var Account_Pay = $(this).closest('tr').find('.Account_Pay').val();
                    Account_Pay = Account_Pay == "" ? 0 : Account_Pay
                    Account_Pay = parseFloat(Account_Pay)
                    // Calc_total_payable((Cash_Pay > 0 ? Cash_Pay : Account_Pay), false);

                    var el = $('#example-select-all').get(0);
                    // If "Select all" control is checked and has 'indeterminate' property
                    if (el && el.checked && ('indeterminate' in el)) {
                        // Set visual state of "Select all" control
                        // as 'indeterminate'
                        el.indeterminate = true;
                    }
                } else {
                    var Amount_To_Be_Paid = $(this).closest('tr').find('.Amount_To_Be_Paid').text();
                    //Calc_total_payable(Amount_To_Be_Paid, true);
                }
            });

            // Handle form submission event
            $('#btn_pay').on('click', function (e) {
                showloader(true)

                var arr = [];

                //var form = this;
                // Iterate over all checkboxes in the table
                table.$('input[type="checkbox"]').each(function () {



                    if (this.checked) {
                        var Cash_Pay = $(this).closest('tr').find('.Cash_Pay').val();
                        Cash_Pay = Cash_Pay == "" ? 0 : Cash_Pay;

                        var Account_Pay = $(this).closest('tr').find('.Account_Pay').val();
                        Account_Pay = Account_Pay == "" ? 0 : Account_Pay;

                        var ESIC = $(this).closest('tr').find('.ESIC').val();
                        ESIC = ESIC == "" ? 0 : ESIC;

                        var Month_Year = $("#Month_Year").val();

                        var Remarks = $(this).closest('tr').find('.Remarks').val();



                        var obj = { "Month_Year": Month_Year, "UserId": $(this).attr("id"), "Cash_Pay": Cash_Pay, "Account_Pay": Account_Pay, "ESIC": ESIC, "Remarks": Remarks }
                        arr.push(obj);
                    }
                });

                if (arr.length == 0) {
                    notify("No User Selected", "error");
                    showloader(false)
                    return false;
                } else {
                    var r = confirm("Are you sure, you want to proceed ?");
                    if (r != true) {
                        showloader(false)
                        return false
                    }
                }



                $.ajax({
                    contentType: 'application/json; charset=utf-8',
                    dataType: 'json',
                    type: "POST",
                    url: '/Salary/AJAX_Pay_Salary',
                    data: JSON.stringify(arr),
                    success: function (res) {
                        notify(res.message, 'success')
                        showloader(false)
                    },
                    failure: function (res) {
                        notify("ERROR", 'danger')
                        console.log(res)
                    },
                    complete: function (jqXHR, status) {
                        setTimeout(function () {
                            window.location.href = window.location.href.replace("True", "False");
                            showloader(false)
                        }, 1000)

                    }
                });

            });
        });
        function Calc_total_payable(amount, add) {

            if (add == undefined) {
                $("#txt_total_payable_amt").text(amount);
                return false;
            }

            var amount_txt = $("#txt_total_payable_amt").text();
            amount_txt = amount_txt == "" || amount_txt == "NaN" ? 0 : amount_txt;

            if (add)
                amount = parseFloat(amount_txt) + parseFloat(amount);
            else
                amount = parseFloat(amount_txt) + (parseFloat(amount) * -1);
            $("#txt_total_payable_amt").text(amount.toFixed(2));
        }

        function Validate_Payable(e) {

            var Remaining_Amount = $(e).closest('tr').find('.Remaining_Amount').attr("data-rem-amt");

            var Cash_Pay = $(e).closest('tr').find('.Cash_Pay').val();
            Cash_Pay = Cash_Pay == "" ? 0 : Cash_Pay;

            var Account_Pay = $(e).closest('tr').find('.Account_Pay').val();
            Account_Pay = Account_Pay == "" ? 0 : Account_Pay;

            var deductions = parseFloat(Cash_Pay) + parseFloat(Account_Pay);
            $(e).closest('tr').find('.Remaining_Amount').text(Remaining_Amount - deductions)

            if (Remaining_Amount - deductions < 0) {
                $(e).closest('tr').find('.Cash_Pay').val(0);
                $(e).closest('tr').find('.Account_Pay').val(0);
                $(e).closest('tr').find('.Remaining_Amount').text(Remaining_Amount);
                notify("Amount cannot be more than remaining amount", 'error')
            }
        }

        function View_Details(UserId) {
            showloader(true)
            var Month_year = $("#Month_Year").val();
            var obj = { "UserId": UserId, "Month_year": Month_year }

            $.ajax({
                contentType: 'application/json; charset=utf-8',
                dataType: 'json',
                type: "POST",
                url: '/Salary/AJAX_View_Details',
                data: JSON.stringify(obj),
                success: function (res) {
                    if (res.StatusCode == 200) {
                        var row = "";
                        var data = JSON.parse(res.Data);
                        console.log(data)
                        $.each(data, function (i, v) {

                            $(".modal-title").text(v.Name)
                            console.log(v)
                            row = row + "<tr>" +
                                "<td>" + v.Payment_Mode + "</td >" +
                                "<td>" + v.Paid_On + "</td >" +
                                "<td>" + v.Paid + "</td>" +
                                "<td>" + v.Remaining_Amount + "</td>" +
                                "<td>" + v.CF_referenceId + "</td>" +
                                "<td>" + v.CF_status + "</td>" +
                                "<td>" + v.CF_message + "</td>" +
                                "<td>" + v.Remarks + "</td>" +
                                "<td style='color: #2700ff;'><a href='#' onclick='GetTransferStatus(" + v.UserId + "," + v.Id + ");' >Reload</a></td>" +
                                "</tr>";
                        })

                        $('#detail_tbl tbody').empty().append(row)
                        $('#salaryModal').modal('show');
                    }
                    else {
                        notify("ERROR", 'danger')
                    }


                },
                failure: function (res) {
                    notify("ERROR", 'danger')
                    console.log(res)
                },
                complete: function (jqXHR, status) {
                    //window.location.href = window.location.href.replace("True", "False");
                    showloader(false)
                }
            });


        }


        function GetTransferStatus(UserId, UserSalaryId) {
            showloader(true)
            var obj = { "UserSalaryId": UserSalaryId }
            $.ajax({
                contentType: 'application/json; charset=utf-8',
                dataType: 'json',
                type: "POST",
                url: '/Salary/AJAX_RefreshTransferStatus',
                data: JSON.stringify(obj),
                success: function (res) {
                    View_Details(UserId);
                },
                failure: function (res) {
                    notify("ERROR", 'danger')
                    console.log(res)
                },
                complete: function (jqXHR, status) {
                    //window.location.href = window.location.href.replace("True", "False");
                    showloader(false)
                }
            });
        }





    </script>
}